<?php

/* =========================================
                  CoffeeScript 
  See GEdit one here: http://goo.gl/ydXqL
  See Pygment one here: http://goo.gl/j0bqx
============================================ */

$coffeescript = array(
// =======================  
// CoffeeScript Root state  
  "coffeescript_root" => array(
    "block_comment" => array( "pattern" => '/###/', "style" => "BlockComment", "action" => "coffeescript_BigComment"),
    'comment' => array( "pattern" => '/#.*/', "style" => "Comment"),
    'regexp0' => array( "pattern" => '#/(\\.|[^[/\\\n]|\[(\\.|[^\]\\\n])*])+/([gim]+\b|\B)#' , "style" => "Regex"),
    'regexp' => array( "pattern" => '#///#', "style" => "Regex", "action" => "coffeescript_regexp"),
    'ops' => array( "pattern" => '#\+\+|--|~|&&|\band\b|\bor\b|\bis\b|\bisnt\b|\bnot\b|\?|:|=|\|\||(<<|>>>?|==?|!=?|[-<>+*%&\|\^/])=?#', 
      "style" => "Operators"),

    'func' => array( "pattern" => '/\([^()]*\)\s*->/', "style" => "funcName"),
    'pars1' => array( "pattern" => '/[{(\[;,]/', "style" => "Pars"),
    'pars2' => array( "pattern" => '/[})\].]/', "style" => "Pars"),
    'kw1' => array( "pattern" => 
      '/\b(?:for|in|of|while|break|return|continue|switch|when|then|if|else|throw|try|catch|finally|new|delete|typeof|instanceof|super|extends|this|class|by)\b/', 
      "style" => "Keywords"),
    'kw2' => array( "pattern" => 
      '/\b(?:true|false|yes|no|on|off|null|NaN|Infinity|undefined)\b/', 
      "style" => "Keywords2"),
    'kw3' => array( "pattern" => 
      '/\b(?:Array|Boolean|Date|Error|Function|Math|netscape|Number|Object|Packages|RegExp|String|sun|decodeURI|decodeURIComponent|encodeURI|encodeURIComponent|eval|isFinite|isNaN|parseFloat|parseInt|document|window)\b/', 
      "style" => "Keywords3"),
    'var1' => array( "pattern" => '/[$a-zA-Z_][a-zA-Z0-9_\.:]*\s*[:=]/', "style" => "Tag"),
    'var2' => array( "pattern" => '/@[$a-zA-Z_][a-zA-Z0-9_\.:]*\s*[:=]/', "style" => "Tag"),
    //'var3' => array( "pattern" => '/@?[$a-zA-Z_][a-zA-Z0-9_]*/', "style" => "Keywords5"),
    'num1' => array( "pattern" => '/[0-9][0-9]*\.[0-9]+([eE][0-9]+)?[fd]?/', "style" => "Number"),
    'num2' => array( "pattern" => '/0x[0-9a-fA-F]+/', "style" => "Number"),
    'num3' => array( "pattern" => '/\d+/', "style" => "Number"),
    "3s_string" => array( "pattern" => "/'''/", "style" => "Special", "action" => "coffeescript_TripleSingleString"),
    'js_string' => array( "pattern" => '/`/', "style" => "Types", "action" => "coffeescript_JSString"),
    'd_string' => array( "pattern" => '/"/', "style" => "DoubleString", "action" => "coffeescript_DoubleString"),
    's_string' => array( "pattern" => "/'/", "style" => "SingleString", "action" => "coffeescript_SingleString"),
  ),
  
// ============== 
// State coffeescript_slash_Starts_regex
"coffeescript_regexp" => array(
  'comment' => array( "pattern" => '/#.*\n/', "style" => "Comment"),
  'out3' => array( "pattern" => '#///#', "style" => "Regex", 'action' => "#pop"),
),

// ====================== 
// State coffeescript_DoubleString
  "coffeescript_JSString" => array(
    'out' => array( "pattern" => '/`/', "style" => "Types", "action" => "#pop")),

// =================
// Sate Triple Single String
"coffeescript_TripleSingleString" => array(
  "esc" => array( "pattern" => '#\\\#', "style" => "StringEsc", "action" => "coffeescript_EscapeDoubleString"),
  "urls" => array("pattern" => "#(\b(?:(?:https?|ftp):\/\/|mailto:)\S*[^\s!\"',.:;?])#", "style" => "Url"),
  "out" => array("pattern" => "/'''/", "style" => "Special", "action" => "#pop")
),
    
// ====================== 
// State coffeescript_DoubleString
  "coffeescript_DoubleString" => array(
    "vars1" => array("pattern" => '/(#)(\{.*?\})/', "style" => array("Special","Entities")),
    'esc' => array("pattern" => '#\\\#', "style" => "StringEsc", "action" => "coffeescript_Escape"),
    'out' => array( "pattern" => '/"/', "style" => "DoubleString", "action" => "#pop")),
  
// ====================== 
// State coffeescript_SingleString
  "coffeescript_SingleString" => array(
    'esc' => array("pattern" => '#\\\#', "style" => "StringEsc", "action" => "coffeescript_Escape"),
    'out' => array( "pattern"   => "/'/", "style" => "SingleString", "action" => "#pop")),

// ===================== 
// State coffeescript_Escape
  "coffeescript_Escape" => array(
    'out' => array("pattern" => '/./', "style" => "StringEsc", "action" => "#pop"),
  ),

// coffeescript_BigComment
"coffeescript_BigComment" => array(
  "url" => array("pattern" => "#(\b(?:(?:https?|ftp):\/\/|mailto:)\S*[^\s!\"',.:;?])#", "style" => "Url"),
  "out" => array( "pattern"   => '/###/', "style" => "BlockComment", "action" => "#pop"),
  )
);

?>